cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Collection of a few useful subroutines which I have written for
c circorbit and related probrams.
c
c michael kramer - february 2000
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer function getcolnum(line)


      implicit none

      character line*(*), blank*1
      integer length, numcol, i
      logical status, new,start

      data blank/' '/

      length=len(line)

      start=(line(1:1).ne.blank) 
      status=start

      numcol=0
      do i=2, length
         new=(line(i:i).ne.blank)
         if (new.and.(new.neqv.status)) numcol=numcol+1
         status=new
      enddo

      getcolnum=numcol

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pgpt8(ndata,x,y,i)

      integer ndata, i,j
      integer maxdata
      parameter (maxdata=5000)
      
      real*8 x(ndata), y(ndata)
      real*4 x4(maxdata), y4(maxdata)

      do j=1, ndata
         x4(j)=sngl(x(j))
         y4(j)=sngl(y(j))
      enddo

      call pgpt(ndata,x4,y4,i)

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pgline8(ndata,x,y)

      integer ndata, j
      integer maxdata
      parameter (maxdata=5000)
      
      real*8 x(ndata), y(ndata)
      real*4 x4(maxdata), y4(maxdata)

      do j=1, ndata
         x4(j)=sngl(x(j))
         y4(j)=sngl(y(j))
      enddo

      call pgline(ndata,x4,y4)

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getlims(x,ndata,xmin,xmax,margin)

      implicit none

      integer ndata, i
      real*8 xmin, xmax, x(ndata), dd
      logical margin

      xmin=x(1)
      xmax=x(1)
      
      do i=2, ndata
         if (x(i).gt.xmax) xmax=x(i)
         if (x(i).lt.xmin) xmin=x(i)
      enddo

      if (margin) then
         dd=0.05*(xmax-xmin)
         xmin=xmin-dd
         xmax=xmax+dd
      endif

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine frame(xmin,xmax,ymin,ymax)
      
      real*8 xmin,xmax,ymin,ymax
      real*4 xmin4,xmax4,ymin4,ymax4

      xmin4=sngl(xmin)
      xmax4=sngl(xmax)
      ymin4=sngl(ymin)
      ymax4=sngl(ymax)

      call pgwindow(xmin4,xmax4,ymin4,ymax4)
      call pgbox('ABCNTS',0.0,0,'ABCNTS',0.0,0)

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pgenv8(xmin,xmax,ymin,ymax,i1,i2)
      
      implicit none
      real*8 xmin,xmax,ymin,ymax
      real*4 xmin4,xmax4,ymin4,ymax4
      integer i1, i2

      xmin4=sngl(xmin)
      xmax4=sngl(xmax)
      ymin4=sngl(ymin)
      ymax4=sngl(ymax)
      call pgenv(xmin4,xmax4,ymin4,ymax4,i1,i2)

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pgmove8(x,y)
      
      implicit none
      real*8 x,y
      real*4 x4,y4

      x4=sngl(x)
      y4=sngl(y)

      call pgmove(x4,y4)

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pgdraw8(x,y)
      
      implicit none
      real*8 x,y
      real*4 x4,y4

      x4=sngl(x)
      y4=sngl(y)

      call pgdraw(x4,y4)

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine errorbars(ndata,x,y,dy)
      
      implicit none

      integer ndata
      real*8 y(ndata), dy(ndata), x(ndata)

      integer maxdata, i
      parameter (maxdata=1000)
      real*4 x4(maxdata), y41(maxdata), y42(maxdata)
      
      do i=1, ndata
         x4(i)=sngl(x(i))
         y41(i)=sngl(y(i)+dy(i))
         y42(i)=sngl(y(i)-dy(i))
      enddo
      call pgerry(ndata, x4, y41, y42, 2.0)


      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine printnum(x,dx,result,ll)

c     -returns a string with value x+-dx to significant numbers
c      ugly but works somehow

      implicit none

      real*8 x, dx
      character stringx*80, stringdx*80,result*80

      integer isfn, i, is, ie, ll

      do i=1, len(stringx)
         stringx(i:i)=' '
         stringdx(i:i)=' '
      enddo

      write(stringx,100) sngl(x)
 100  format(f35.20)
      

      if (dx.le.1.0) then

         isfn=abs(min(log10(dx)-1,0))

         write(stringdx,200) sngl(dx)
 200     format(f22.20)

         is=17+isfn
         stringx(is:is+4)=' +/- '
         is=is+4
         do i=1, isfn+3
            ie=is+i
            stringx(ie:ie)=stringdx(i:i)
         enddo
         ie=is+isfn+3+1
         do i=ie, len(stringx)
            stringx(i:i)=' '
         enddo

         is=1
         do while (stringx(is:is).eq.' ') 
            is=is+1
         enddo
         do i=is, len(stringx)
            if (stringx(i:i).ne.' ') ll=i-is+1
            result(i-is+1:i-is+1)=stringx(i:i)
         enddo
         
      else

         write(stringdx,100) sngl(dx)

         is=1
         do while (stringx(is:is).eq.' ') 
            is=is+1
         enddo
         i=0
         do while (stringx(is:is).ne.'.') 
            i=i+1
            result(i:i)=stringx(is:is)
            is=is+1
         enddo

         i=i+1
         result(i:i+2)=stringx(is:is+2)
         i=i+3

         result(i:i+4)=' +/- '
         i=i+4

         is=1
         do while (stringdx(is:is).eq.' ') 
            is=is+1
         enddo
         do while (stringdx(is:is).ne.'.') 
            i=i+1
            result(i:i)=stringdx(is:is)
            is=is+1
         enddo
         i=i+1
         result(i:i+2)=stringx(is:is+2)
         ll=i+2

      endif

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine myhist(nbin,x,y)

      implicit none

      integer nbin, i
      
      real*8 x(nbin), y(nbin), dx,y0, xp

      dx=0.495d0*(x(2)-x(1))
      y0=0.0d0
      xp=x(1)-dx
      call pgmove8(xp,y0)

      do i=1, nbin
         xp=x(i)-dx
         call pgdraw8(xp,y0)
         call pgdraw8(xp,y(i))
         xp=x(i)+dx
         call pgdraw8(xp,y(i))
         call pgdraw8(xp,y0)         
      enddo

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine checkdist(x,ndata,x0,dx0,dx0l,dx0u,factor,plot)
      
      implicit none

      integer ndata
      real*8 x(ndata), x0, dx0, dx0l, dx0u
      real*4 factor
      logical plot

      integer nbin, nbinmax, ibin, i, imax, fail
      parameter (nbinmax=1000)
      real*8 dx, xmin, xmax, ymin, ymax, sum
      real*8 xdist(nbinmax), ydist(nbinmax)

      real*8 problevel, xlow, xhigh
      parameter (problevel=0.68)

      nbin=ndata/100
      nbin=min(nbinmax,nbin)

      call getlims(x,ndata,xmin,xmax,.true.)
      dx=(xmax-xmin)/dble(nbin)
      do i=1,nbin
         xdist(i)=dble(factor)*(xmin+(dble(i)-0.5d0)*dx)
         ydist(i)=0.0
      enddo

      ymax=0.0
      imax=0
      sum=1.0d0/dble(ndata) ! normalize it right away
      do i=1, ndata
         ibin=int((x(i)-xmin)/dx+0.5d0)
         ydist(ibin)=ydist(ibin)+sum
         if (ydist(ibin).gt.ymax) then
            ymax=ydist(ibin)
            imax=ibin
         endif
      enddo
      x0=xmin+(dble(imax)+0.5d0)*dx

      fail=0
      i=imax
      sum=0.0

      do while (sum.le.0.5*problevel) 
         sum=sum+ydist(i)
         i=i+1
         if (i.gt.nbin) then
            write(*,*) 'CHECKDIST: Problems finding xhigh.'
            fail=fail+1
            sum=problevel
            i=imax
         endif
      enddo
      xhigh=xmin+(dble(i)+0.5d0)*dx
      dx0u=xhigh-x0
      
      i=imax
      sum=0.0
      do while (sum.le.0.5*problevel) 
         sum=sum+ydist(i)
         i=i-1
         if (i.lt.1) then
            write(*,*) 'CHECKDIST: Problems finding xlow.'
            fail=fail+1
            sum=problevel
            i=imax
         endif
      enddo
      xlow=xmin+(dble(i)+0.5d0)*dx
      dx0l=x0-xlow

c     - three sigma
c      dx0=3.0*max(abs(x0-xlow),abs(xhigh-x0))
c     - one sigma
      dx0=1.0*max(abs(x0-xlow),abs(xhigh-x0))
      if (fail.eq.2) write(*,*) 'CHECKDIST: Error without meaning.',dx0

c     -- plot distribution if wanted
      if (plot) then
         xmax=xmax*factor
         xmin=xmin*factor
         ymin=0.0
         call pgenv8(xmin,xmax,ymin,ymax,0,1)
         call myhist(nbin,xdist,ydist)
      endif      

      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
